class Locmare.FormModule.FieldModule.HelperModule.Slider extends Locmare.FormModule.FieldModule.HelperModule.Base
  tagName: 'span'
  className: 'slider'
  
  # wrapper
  initialize: (options) ->
    super(options)
    @check = new Tag.Checkbox({value: 1, checked: @is_enable()})
    @slider = new Locmare.FormModule.FieldModule.HelperModule.SliderModule.Slider({
      parent: this, field: @field
    })
    @listenTo(@check, 'click', @click_check)
    @listenTo(@slider, 'slide', @slider_change)
  
  render: () ->
    @attr = {
    }
    this.$el.attr(@attr)
    this.$el.html('')
    this.$el.append(@check.render().el)
    this.$el.append(@slider.render().el)
    @click_check()    # init show/hide
    this
  
  refresh: () ->
    null
  
  is_enable: () ->
    _.isNumber(@field.value())
  
  slider_change: (value) -> 
    @field.tag.$el.val(value)
    @field.trigger('change')
  
  click_check: () -> 
    if @check.checked
      @slider.enable()
    else
      @slider.disable()
  
class Locmare.FormModule.FieldModule.HelperModule.SliderModule
class Locmare.FormModule.FieldModule.HelperModule.SliderModule.Slider extends Tag.Span
  events: {
    slidechange: 'slider_change'
  }
  
  initialize: (options) ->
    @field = options.field
    @parent = options.parent
    super({})
    this.$el.addClass('per-slider')
  
  render: () ->
    this.$el.html('')
    this.$el.slider {
      orientation: 'horizontal',
      range: 'min',
      max: 100,
      value: 0
    }
    this
  
  enable: () ->
    @parent.slider_change(@field.value() || 0)
    #@field.set(@field.value() || 0)
    #this.$el.slider({value: @field.value()})
    this.$el.attr({style: 'display: inline;'})
    @field.tag.show()
  
  disable: () ->
    @parent.slider_change(undefined)
    #@field.set(undefined)
    @field.tag.hide()
    this.$el.attr({style: 'display: none;'})
  
  slider_change: (event, ui) -> 
    @trigger('slide', ui.value)
  
  volume: () ->
    (@field.value() >> @shift) & 0xFF
  
