class Pettanr.View.Social extends Pettanr.View
  className: 'social'
  
  constructor: (@item, @context, options) ->
    super(options)
  
  initialize: (options) ->
    super(options)
    @twitter = new Pettanr.View.Social.Twitter()
    @facebook = new Pettanr.View.Social.Facebook()
    @hatena = new Pettanr.View.Social.Hatena()
  
  render: () ->
    this.$el.html('')
    this.$el.append(@twitter.render().el)
    this.$el.append(@facebook.render().el)
    this.$el.append(@hatena.render().el)
    @append_rb()
    this
  
  refresh: () ->
    @facebook.refresh()
  
class Pettanr.View.Social.Twitter extends Pettanr.View
  className: 'social-button'
  
  render: () ->
    this.$el.html('')
    this.$el.append('<a href="http://twitter.com/share" class="twitter-share-button"data-count="horizontal" data-via="opsatwit"data-lang="ja">Tweet</a><script type="text/javascript"src="http://platform.twitter.com/widgets.js"></script>')
    this
  
  refresh: () ->
  
class Pettanr.View.Social.Facebook extends Pettanr.View
  className: 'social-button'
  
  render: () ->
    this.$el.html('')
    this.$el.append('<div id="fb-root"></div>')
    this.$el.append('<div class="fb-like" data-href="' + window.location.href + '" data-layout="button_count" data-action="like" data-show-faces="true" data-share="false"></div>')
    this
  
  refresh: () ->
    FB.XFBML.parse()
  
class Pettanr.View.Social.Hatena extends Pettanr.View
  className: 'social-button'
  
  render: () ->
    this.$el.html('')
    url = 'http://b.hatena.ne.jp/entry/' + window.location.href
    console.log(url)
    title = document.title
    this.$el.append('<a href="' + url + '" class="hatena-bookmark-button" data-hatena-bookmark-title="' + title + '" data-hatena-bookmark-layout="standard-balloon" data-hatena-bookmark-lang="ja" title="このエントリーをはてなブックマークに追加"><img src="https://b.st-hatena.com/images/entry-button/button-only@2x.png" alt="このエントリーをはてなブックマークに追加" width="20" height="20" style="border: none;" /></a><script type="text/javascript" src="https://b.st-hatena.com/js/bookmark_button.js" charset="utf-8" async="async"></script>')
    this
  
  refresh: () ->
  
