module Editor
  module EditorModule
    class Pool
      attr_accessor :editor, :root_item, :pool, :index
      def initialize editor, root_item
        @editor = editor
        @root_item = root_item
        @pool = {}
        @index = 1
        self.editize
      end
      
      # regist stored element
      def editize
        @root_item.boosts 'post'
        self.register nil, @root_item
        editize_element @root_item
      end
      
      def editize_element parent
        parent.class.child_element_names.each do |element_name|
          e = parent.__send__ element_name
          e = [e] unless e.respond_to?(:each)
          e.each do |element_item|
            element_item.boosts 'post'
            self.register parent, element_item
            self.editize_element element_item
          end
        end
      end
      
      def register parent, item
        item.extend Peta::Editize
        item.editor = @editor
        item.parent = parent if parent
        if item.new_record?
          item.pool_id = @index
          @index += 1
        else
          item.pool_id = item.id
        end
        @pool[item.item_name] ||= {'stored' => {}, 'new'  => {}}
        @pool[item.item_name][item.dom_pool_type] ||= {}
        @pool[item.item_name][item.dom_pool_type][item.pool_id] = item
      end
      
      def unregister item
        
      end
      
    end
    
  end
end
