require_dependency "locmare/profiler/association/belongs_to"
require_dependency "locmare/profiler/association/has_many"
require_dependency "locmare/profiler/association/has_one"
module Locmare
  module ProfilerModule
    class Association
      include AssociationModule
      attr :profiler, :association_manifest,
        :belongs_to, :has_many, :has_one
      def initialize profiler, association_manifest
        @profiler = profiler
        @association_manifest = association_manifest
        @belongs_to = @association_manifest.belongs_to.map {|belongs_to_manifest|
          BelongsTo.new self, belongs_to_manifest
        }
        @has_many = @association_manifest.has_many.map {|list_name|
          HasMany.new self, list_name
        }
        @has_one = @association_manifest.has_one.map {|list_name|
          HasOne.new self, list_name
        }
      end
      
      def item
        @profiler.item
      end
      
      def model_manifest
        ::Manifest.manifest.models[@profiler.item_name]
      end
      
      def model_attribute_manifest
        model_manifest.attributes[@column_name]
      end
      
      def template_dir 
        @profiler.template_dir
      end
      
      def template_file_name
        "associations"
      end
      
      def template_name
        self.template_dir + self.template_file_name
      end
      
      def each_belongs_to_filer
        @belongs_to.each {|b|
          yield b.filer
        }
      end
      
      def each_has_many_filer
        @has_many.each {|h|
          yield h.filer
        }
      end
      
      def each_has_one_filer
        @has_one.each {|h|
          yield h.filer
        }
      end
      
    end
  end
end
